plugins {
    groovy
}

repositories {
    mavenLocal()
    mavenCentral()
    maven { url = uri("https://mirrors.cloud.tencent.com/nexus/repository/maven-public/") }
}

group = "com.example"
version = "1.0"
description = "Demo project for Solon"


dependencies {
    implementation(platform("org.noear:solon-parent:2.7.3"))
    
    implementation("org.noear:solon-api")
    implementation("org.noear:solon.logging.logback")
    implementation("org.codehaus.groovy:groovy:3.0.14")

    testImplementation("org.noear:solon-test")
}

tasks.withType<JavaCompile> {
    options.encoding = "UTF-8"
    options.compilerArgs.add("-parameters")
}
tasks.withType<GroovyCompile> {
    groovyOptions.setParameters(true)
}

tasks.withType<Jar> {
    manifest {
        attributes.apply {
            set("Main-Class", "com.example.demo.App")
        }
    }
    
    dependsOn(configurations.runtimeClasspath)

    duplicatesStrategy = DuplicatesStrategy.EXCLUDE
    from(configurations.runtimeClasspath.get().map {
        if (it.isDirectory) it else zipTree(it)
    })

    from(sourceSets.main.get().output)
}